;
; afxmark.ahk
;   Extended mark operation script for Afx
;   Written by Yak!
;
;   $URL: https://yak.myhome.cx/repos/source/afxscrpt/trunk/afxmark.ahk $
;   $Date: 2007-06-16 00:52:05 +0900 (Sat, 16 Jun 2007) $
;   $Rev: 407 $
;

#Include %A_ScriptDir%
#Include afxctrl.ahk

; [LROP] [[CSL<sortopt>] [CSR<sortopt>] KEEP]|NOKEEP [S<sortopt>] [TOP[EX]|BOTTOM[EX]|UP[EX]|DOWN[EX]] [CLEAR|OR|ASK] [<num>]
Loop, %0%
{
    var:=%A_Index%
    if (RegExMatch(var, "i)^[LROP]$"))
    {
        StringUpper, target, var
    } else if(RegExMatch(var, "i)^CSL"))
    {
        StringTrimLeft, lsort, var, 3
        StringUpper, lsort, lsort
    } else if(RegExMatch(var, "i)^CSR"))
    {
        StringTrimLeft, rsort, var, 3
        StringUpper, rsort, rsort
    } else if(RegExMatch(var, "i)^(KEEP|NOKEEP)$"))
    {
        StringUpper, keepmode, var
    } else if(RegExMatch(var, "^[Ss]"))
    {
        StringTrimLeft, sort, var, 1
        StringUpper, sort, sort
    } else if(RegExMatch(var, "i)^(TOP|BOTTOM|UP|DOWN)(EX)?$"))
    {
        StringUpper, mode, var
    } else if(RegExMatch(var, "i)^(CLEAR|OR|ASK)$"))
    {
        StringUpper, markmode, var
    } else if(RegExMatch(var, "^[0-9]+$"))
    {
        num:=var
    }
}
if target =
    target=P
if keepmode =
    keepmode=KEEP
if mode =
    mode=DOWN
if markmode =
    markmode=ASK
if num =
    num=1

; target  L  R ɐK
If target = P
    target:=AfxGetPWin()
If target = O
	target:=AfxGetOWin()

If target =
{
	MsgBox, Can't use P or O as target when Afx is not active
	ExitApp
}

If sort
    AfxCommand("-S" . target . sort)

If target = L
{
    top:=AfxSizeInfo2DirNum(AfxGetLSizeInfo())+1
    index:=AfxGetLCursorIndex()
    count:=AfxGetLCount()-1
    selcount:=AfxGetLSelectCount()
} else {
    top:=AfxSizeInfo2DirNum(AfxGetRSizeInfo())+1
    index:=AfxGetRCursorIndex()
    count:=AfxGetRCount()-1
    selcount:=AfxGetRSelectCount()
}
If index < %top%
    index:=top
If selcount > 0
{
	If markmode = ASK
	{
		MsgBox, 4, Confirmation, Mark already exists. Clear?
		IfMsgBox, Yes
		{
			markmode=CLEAR
		}
	}
	If markmode = CLEAR
		If target = L
		    AfxDeselectLRange(0, count)
		Else
			AfxDeselectRRange(0, count)
}

If mode = TOP
{
    begin:=top
    end:=begin + num - 1
    if end > %count%
        end:=count
} else if mode = TOPEX
{
    begin:=top + 1
    end:=begin + num - 1
    if end > %count%
        end:=count
} else If mode = BOTTOM
{
    end:=count
    begin:=end - num + 1
    if begin < %top%
        begin:=top
} else If mode = BOTTOMEX
{
    end:=count - 1
    begin:=end - num + 1
    if begin < %top%
        begin:=top
} else If mode = UP
{
    end:=index
    begin:=index - num + 1
    if begin < %top%
        begin:=top
} else If mode = UPEX
{
    end:=index-1
    begin:=index - num + 1
    if begin < %top%
        begin:=top
} else If mode = DOWN
{
    begin:=index
    end:=begin + num -1
    if end > %count%
        end:=count
} else If mode = DOWNEX
{
    begin:=index+1
    end:=begin + num -1
    if end > %count%
        end:=count
}
If(begin < end)
{
    If target = L
    {
        AfxSelectLRange(begin, end)
        AfxUpdateLMarkInfo()
    } else {
        AfxSelectRRange(begin, end)
        AfxUpdateRMarkInfo()
    }
}
If(keepmode = "KEEP" and lsort <> "" and rsort <> "")
{
	AfxCommand("-SL" . lsort . " -SR" . rsort)
}
